//****************************************************************************
// FileName  : WD6117C.CPP
// Function  : Watch Dog Demo Program
// Design's  : By Ray
// BuildDate : 07/05/2001 Version 1.0
//****************************************************************************

//Include file as follows:
#include <conio.h>
#include <stdio.h>

//Function declare as follows:
void enable_wd_1sec();
void disable_wd();

//Main program start
void main()
{
char inkey;

for(;;)
   {
   clrscr();
   printf("Press <Y> or <y> run Watch Dog. \n");
   printf("Press <Q> or <q> quit program. \n");
   printf("Please Input Key Value ==> ");
   scanf("%c",&inkey);

   switch(inkey)
     {
     case 'Y':
     case 'y':
             printf("Waiting 6 second.");
             enable_wd_1sec();
             return;
     case 'Q':
     case 'q':
             disable_wd();
             return;
     }
   }
}

//===============================================
// Function : Enable Watch Dog
// Enter    : None
// Return   : None
//===============================================
void enable_wd_1sec()
{
char set_wd;

        outport(0x22,0x13);     //Unlock Configuration Register
        outport(0x23,0xc5);

        outport(0x22,0x3b);     //Set WatchDog Timer MS2
        outport(0x23,0x03);

        outport(0x22,0x3a);     //Set WatchDog Timer MS1
        outport(0x23,0x03);

        outport(0x22,0x39);     //Set WatchDog Timer MS0
        outport(0x23,0x03);

        outport(0x22,0x38);     //Set Trigger Signal is System Reset
        outport(0x23,0xd0);

        outport(0x22,0x37);     //Enable M6117C WatchDog
        set_wd=inport(0x23);
        outport(0x23,set_wd|0x40);

        outport(0x22,0x13);     //Lock Configuration Register
        outport(0x23,0x00);
}

//===============================================
// Function : Disable Watch Dog
// Enter    : None
// Return   : None
//===============================================
void disable_wd()
{
char set_wd;

        outport(0x22,0x13);     //Unlock Configuration Register
        outport(0x23,0xc5);

        outport(0x22,0x37);     //Clrscr WatchDog Timer
        set_wd=inport(0x23);
        outport(0x23,set_wd&0xbf);

        outport(0x22,0x13);     //Lock Configuration Register
        outport(0x23,0x00);
}
